Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2696)
@@ -1608,19 +1737,23 @@
 !--    can be obtain via parameterization of Mason (2000) / 
 !--    Krayenhoff and Voogt (2006).
-!--    To do: detailed investigation which approach is better!
+!--    To do: detailed investigation which approach gives more reliable results!
+!--    Please note, in case of very small friction velocity, e.g. in little 
+!--    holes, the resistance can become negative. For this reason, limit r_a 
+!--    to positive values. 
        IF ( horizontal  .OR.  .NOT. aero_resist_kray )  THEN
-          surf%r_a(m) = ( pt1 - surf_lsm_h%pt_surface(m) ) /                   &
-                        ( surf%ts(m) * surf%us(m) + 1.0E-20_wp )
+          surf%r_a(m) = ABS( ( surf%pt1(m) - surf%pt_surface(m) ) /            &
+                             ( surf%ts(m) * surf%us(m) + 1.0E-20_wp ) )
        ELSE
           surf%r_a(m) = 1.0_wp / ( 11.8_wp + 4.2_wp *                          &
-                        SQRT( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 +      &
-                              ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 +      &
-                              ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2 )      &
+                        SQRT( MAX( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 + &
+                                   ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 + &
+                                   ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2,  &
+                              0.01_wp ) )                                      &
                                  )
        ENDIF
 !
 !--    Make sure that the resistance does not drop to zero for neutral 
-!--    stratification
-       IF ( ABS( surf%r_a(m) ) < 1.0_wp )  surf%r_a(m) = 1.0_wp
+!--    stratification. 
+       IF ( surf%r_a(m) < 1.0_wp )  surf%r_a(m) = 1.0_wp
 !
 !--    Second step: calculate canopy resistance r_canopy
@@ -1629,7 +1762,7 @@
 !--    f1: correction for incoming shortwave radiation (stomata close at 
 !--    night)
-       f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k_rad,j+j_off,i+i_off)         &
-                 + 0.05_wp ) / (0.81_wp * (0.004_wp                            &
-                 * rad_sw_in(k_rad,j+j_off,i+i_off) + 1.0_wp)) )
+       f1 = MIN( 1.0_wp, ( 0.004_wp * surf%rad_sw_in(m) + 0.05_wp ) /          &
+                        (0.81_wp * (0.004_wp * surf%rad_sw_in(m)               &
+                         + 1.0_wp)) )
 !
 !--    f2: correction for soil moisture availability to plants (the 
@@ -1665,5 +1798,5 @@
 !
 !--       Calculate vapour pressure
-          e  = qv1 * surface_pressure / ( qv1 + 0.622_wp )
+          e  = surf%qv1(m) * surface_pressure / ( surf%qv1(m) + 0.622_wp )
           f3 = EXP ( - surf%g_d(m) * (e_s - e) )
        ELSE
@@ -1682,6 +1815,6 @@
 
 
-       f2 = ( surf_m_soil%var_2d(nzb_soil,m) - m_min )                         &
-            / ( surf%m_fc(nzb_soil,m) - m_min )
+       f2 = ( surf_m_soil%var_2d(nzb_soil,m) - m_min ) /                       &
+            ( surf%m_fc(nzb_soil,m) - m_min )
        f2 = MAX( f2, 1.0E-20_wp )
        f2 = MIN( f2, 1.0_wp     )
@@ -1698,5 +1831,5 @@
        IF ( surf%pavement_surface(m) )  THEN
           m_liq_max = m_max_depth * 5.0_wp
-          surf%c_liq(m) = MIN( 1.0_wp, (surf_m_liq%var_1d(m) / m_liq_max)**0.67 )
+          surf%c_liq(m) = MIN( 1.0_wp, ( surf_m_liq%var_1d(m) / m_liq_max)**0.67 )
        ELSE
           m_liq_max = m_max_depth * ( surf%c_veg(m) * surf%lai(m)              &
@@ -1710,5 +1843,5 @@
 !--    In case of dewfall, set evapotranspiration to zero
 !--    All super-saturated water is then removed from the air
-       IF ( humidity  .AND.  q_s <= qv1 )  THEN
+       IF ( humidity  .AND.  q_s <= surf%qv1(m) )  THEN
           surf%r_canopy(m) = 0.0_wp
           surf%r_soil(m)   = 0.0_wp
@@ -1747,6 +1880,9 @@
        dq_s_dt = 0.622_wp * e_s_dt / ( surface_pressure - e_s_dt )
 !
-!--    Add LW up so that it can be removed in prognostic equation
-       surf%rad_net_l(m) = rad_net(j,i) + rad_lw_out(nzb,j,i)
+!--    Calculate net radiation radiation without longwave outgoing flux because
+!--    it has a dependency on surface temperature and thus enters the prognostic 
+!--    equations directly
+       surf%rad_net_l(m) = surf%rad_sw_in(m) - surf%rad_sw_out(m)              &
+                           + surf%rad_lw_in(m)
 !
 !--    Calculate new skin temperature
@@ -1754,25 +1890,27 @@
 !
 !--       Numerator of the prognostic equation
-          coef_1 = surf%rad_net_l(m) + rad_lw_out_change_0(j,i)                &
-                   * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)            &
-                   + f_shf * pt1 + f_qsws * ( qv1 - q_s                        &
+          coef_1 = surf%rad_net_l(m) + surf%rad_lw_out_change_0(m)             &
+                   * surf_t_surface%var_1d(m) - surf%rad_lw_out(m)             &
+                   + f_shf * surf%pt1(m) + f_qsws * ( surf%qv1(m) - q_s        &
                    + dq_s_dt * surf_t_surface%var_1d(m) ) + lambda_surface     &
                    * surf_t_soil%var_2d(nzb_soil,m)
+
 !
 !--       Denominator of the prognostic equation
-          coef_2 = rad_lw_out_change_0(j,i) + f_qsws * dq_s_dt                 &
+          coef_2 = surf%rad_lw_out_change_0(m) + f_qsws * dq_s_dt              &
                    + lambda_surface + f_shf / exn
        ELSE
 !
 !--       Numerator of the prognostic equation
-          coef_1 = surf%rad_net_l(m) + rad_lw_out_change_0(j,i)                &
-                   * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)            &
-                   + f_shf * pt1  + lambda_surface                             &
+          coef_1 = surf%rad_net_l(m) + surf%rad_lw_out_change_0(m)             &
+                   * surf_t_surface%var_1d(m) - surf%rad_lw_out(m)             &
+                   + f_shf * surf%pt1(m)  + lambda_surface                     &
                    * surf_t_soil%var_2d(nzb_soil,m)
 !
 !--       Denominator of the prognostic equation
-          coef_2 = rad_lw_out_change_0(j,i) + lambda_surface + f_shf / exn
+          coef_2 = surf%rad_lw_out_change_0(m) + lambda_surface + f_shf / exn
 
        ENDIF
+
 
        tend = 0.0_wp
@@ -1819,9 +1957,21 @@
 !--    computing time for the radiation code).
        IF ( ABS( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) )       &
-            > 0.2_wp  .AND. unscheduled_radiation_calls )  THEN
+            > 0.2_wp  .AND. &
+            unscheduled_radiation_calls )  THEN
           force_radiation_call_l = .TRUE.
        ENDIF
 
-       pt(k+k_off,j+j_off,i+i_off) = surf_t_surface_p%var_1d(m) / exn  !is actually no air temperature
+
+!        IF ( surf_t_surface_p%var_1d(m) < 270.0_wp .OR. surf_t_surface_p%var_1d(m) > 350.0_wp )  THEN
+!           PRINT*, "myid: ", myid
+!           PRINT*, "m: ", m
+!           PRINT*, "i,j,k: ", i, j, k
+!           PRINT*, "pt_p: ", surf_t_surface_p%var_1d(m)
+!           PRINT*, "f_shf: ", f_shf
+!           PRINT*, "f_qsws: ", f_qsws
+!         ENDIF
+
+
+!        pt(k+k_off,j+j_off,i+i_off) = surf_t_surface_p%var_1d(m) / exn  !is actually no air temperature
        surf%pt_surface(m)          = surf_t_surface_p%var_1d(m) / exn
 
@@ -1829,10 +1979,10 @@
 !--    Calculate fluxes
        surf%rad_net_l(m) = surf%rad_net_l(m) +                                 &
-                            rad_lw_out_change_0(j,i)                           &
-                          * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)     &
-                          - rad_lw_out_change_0(j,i) * surf_t_surface_p%var_1d(m)
-
-       rad_net(j,i) = surf%rad_net_l(m)
-       rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i) + rad_lw_out_change_0(j,i) *  &
+                            surf%rad_lw_out_change_0(m)                        &
+                          * surf_t_surface%var_1d(m) - surf%rad_lw_out(m)      &
+                          - surf%rad_lw_out_change_0(m) * surf_t_surface_p%var_1d(m)
+
+       surf%rad_net(m) = surf%rad_net_l(m)
+       surf%rad_lw_out(m) = surf%rad_lw_out(m) + surf%rad_lw_out_change_0(m) * &
                      ( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) )
 
@@ -1840,21 +1990,20 @@
                                              - surf_t_soil%var_2d(nzb_soil,m) )
 
-       surf%shf(m) = - f_shf * ( pt1 - surf%pt_surface(m) ) / cp
-
+       surf%shf(m) = - f_shf * ( surf%pt1(m) - surf%pt_surface(m) ) / cp
 
        IF ( humidity )  THEN
-          surf%qsws(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                     &
+          surf%qsws(m)  = - f_qsws * ( surf%qv1(m) - q_s + dq_s_dt             &
                           * surf_t_surface%var_1d(m) - dq_s_dt *               &
                             surf_t_surface_p%var_1d(m) )
 
-          surf%qsws_veg(m)  = - f_qsws_veg  * ( qv1 - q_s                      &
+          surf%qsws_veg(m)  = - f_qsws_veg  * ( surf%qv1(m) - q_s              &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
 
-          surf%qsws_soil(m) = - f_qsws_soil * ( qv1 - q_s                      &
+          surf%qsws_soil(m) = - f_qsws_soil * ( surf%qv1(m) - q_s              &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
 
-          surf%qsws_liq(m)  = - f_qsws_liq  * ( qv1 - q_s                      &
+          surf%qsws_liq(m)  = - f_qsws_liq  * ( surf%qv1(m) - q_s              &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
@@ -1866,5 +2015,5 @@
           surf%r_s(m) = 1.0E10_wp
        ELSE
-          surf%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
+          surf%r_s(m) = - rho_lv * ( surf%qv1(m) - q_s + dq_s_dt               &
                           * surf_t_surface%var_1d(m) - dq_s_dt *               &
                             surf_t_surface_p%var_1d(m) ) /                     &
@@ -1954,5 +2103,5 @@
                       intermediate_timestep_count_max )  THEN
                 surf_tm_liq_m%var_1d(m) = -9.5625_wp * tend +                  &
-                                              5.3125_wp * surf_tm_liq_m%var_1d(m)
+                                           5.3125_wp * surf_tm_liq_m%var_1d(m)
              ENDIF
           ENDIF
@@ -2015,5 +2164,5 @@
           q_s = 0.622_wp * e_s / ( surface_pressure - e_s )
 
-          resistance = surf%r_a(m) / ( surf%r_a(m) + surf%r_s(m) )
+          resistance = surf%r_a(m) / ( surf%r_a(m) + surf%r_s(m) + 1E-5_wp )
 
 !
@@ -2028,5 +2177,4 @@
                                           q(k,j,i)
           ENDIF
-
 !
 !--       Update virtual potential temperature
@@ -2098,7 +2246,11 @@
        ENDIF
 
-       WRITE( io, 4 ) TRIM( vegetation_type_name(vegetation_type) ),           &
-                        TRIM (soil_type_name(soil_type) )
-       WRITE( io, 5 ) TRIM( soil_depth_chr ), TRIM( t_soil_chr ),              &
+       IF ( vegetation_type_f%from_file )  THEN
+          WRITE( io, 5 )
+       ELSE
+          WRITE( io, 4 ) TRIM( vegetation_type_name(vegetation_type) ),        &
+                         TRIM (soil_type_name(soil_type) )
+       ENDIF
+       WRITE( io, 6 ) TRIM( soil_depth_chr ), TRIM( t_soil_chr ),              &
                         TRIM( m_soil_chr ), TRIM( roots_chr ),                 &
                         TRIM( vertical_index_chr )
@@ -2111,5 +2263,7 @@
 4   FORMAT ('    --> Land surface type  : ',A,/                                &
             '    --> Soil porosity type : ',A)
-5   FORMAT (/'    Initial soil temperature and moisture profile:'//            &
+5   FORMAT ('    --> Land surface type  : read from file' /                    &
+            '    --> Soil porosity type : read from file' )
+6   FORMAT (/'    Initial soil temperature and moisture profile:'//            &
             '       Height:        ',A,'  m'/                                  &
             '       Temperature:   ',A,'  K'/                                  &
@@ -2117,4 +2271,5 @@
             '       Root fraction: ',A,'  '/                                   &
             '       Grid point:    ',A)
+
 
     END SUBROUTINE lsm_header
@@ -2133,19 +2288,18 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i     !< running index
-       INTEGER(iwp) ::  i_off !< index offset of surface element, seen from atmospheric grid point 
-       INTEGER(iwp) ::  j     !< running index
-       INTEGER(iwp) ::  j_off !< index offset of surface element, seen from atmospheric grid point 
-       INTEGER(iwp) ::  k     !< running index
-       INTEGER(iwp) ::  kn    !< running index
-       INTEGER(iwp) ::  ko    !< running index
-       INTEGER(iwp) ::  kroot !< running index
-       INTEGER(iwp) ::  kzs   !< running index
-       INTEGER(iwp) ::  l     !< running index surface facing
-       INTEGER(iwp) ::  m     !< running index
+       INTEGER(iwp) ::  i                       !< running index
+       INTEGER(iwp) ::  i_off                   !< index offset of surface element, seen from atmospheric grid point 
+       INTEGER(iwp) ::  j                       !< running index
+       INTEGER(iwp) ::  j_off                   !< index offset of surface element, seen from atmospheric grid point 
+       INTEGER(iwp) ::  k                       !< running index
+       INTEGER(iwp) ::  kn                      !< running index
+       INTEGER(iwp) ::  ko                      !< running index
+       INTEGER(iwp) ::  kroot                   !< running index
+       INTEGER(iwp) ::  kzs                     !< running index
+       INTEGER(iwp) ::  l                       !< running index surface facing
+       INTEGER(iwp) ::  m                       !< running index
+       INTEGER(iwp) ::  st                      !< soil-type index
        INTEGER(iwp) ::  n_soil_layers_total     !< temperature variable, stores the total number of soil layers + 4 
-
-
-       REAL(wp) :: pt1   !< potential temperature at first grid level
+       INTEGER(iwp) ::  n_surf                  !< number of surface types of given surface element 
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  bound, bound_root_fr  !< temporary arrays for storing index bounds
@@ -2157,5 +2311,6 @@
 !--    If no cloud physics is used, rho_surface has not been calculated before
        IF (  .NOT.  cloud_physics )  THEN
-          rho_surface = surface_pressure * 100.0_wp / ( r_d * pt_surface * exn )
+          CALL calc_mean_profile( pt, 4 )
+          rho_surface = surface_pressure * 100.0_wp / ( r_d * hom(nzb+1,1,4,0) * exn )
        ENDIF
 
@@ -2206,5 +2361,18 @@
           surf_lsm_v(l)%r_soil     = 0.0_wp
        ENDDO
-   
+
+!
+!--    Set initial values for prognostic soil quantities
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+          t_soil_h%var_2d = 0.0_wp
+          m_soil_h%var_2d = 0.0_wp
+          m_liq_h%var_1d  = 0.0_wp
+
+          DO  l = 0, 3
+             t_soil_v(l)%var_2d = 0.0_wp
+             m_soil_v(l)%var_2d = 0.0_wp
+             m_liq_v(l)%var_1d  = 0.0_wp
+          ENDDO
+       ENDIF
 !
 !--    Allocate 3D soil model arrays
@@ -2261,50 +2429,143 @@
           ENDIF      
        ENDDO
-
+!
+!--    Allocate albedo type and emissivity for vegetation, water and pavement 
+!--    fraction.
+!--    Set default values at each surface element. 
+       ALLOCATE ( surf_lsm_h%albedo_type(0:2,1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%emissivity(0:2,1:surf_lsm_h%ns) )
+       surf_lsm_h%albedo_type = 0      
+       surf_lsm_h%emissivity  = emissivity
+       DO  l = 0, 3
+          ALLOCATE ( surf_lsm_v(l)%albedo_type(0:2,1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%emissivity(0:2,1:surf_lsm_v(l)%ns)  )
+          surf_lsm_v(l)%albedo_type = 0
+          surf_lsm_v(l)%emissivity  = emissivity
+       ENDDO
+!
+!--    Allocate arrays for relative surface fraction. 
+!--    0 - vegetation fraction, 2 - water fraction, 1 - pavement fraction
+       ALLOCATE( surf_lsm_h%frac(0:2,1:surf_lsm_h%ns) )
+       surf_lsm_h%frac = 0.0_wp
+       DO  l = 0, 3
+          ALLOCATE( surf_lsm_v(l)%frac(0:2,1:surf_lsm_v(l)%ns) )
+          surf_lsm_v(l)%frac = 0.0_wp
+       ENDDO
+!
+!--    For vertical walls only - allocate special flag indicating if any building is on
+!--    top of any natural surfaces. Used for initialization only. 
+       DO  l = 0, 3
+          ALLOCATE( surf_lsm_v(l)%building_covered(1:surf_lsm_v(l)%ns) )
+       ENDDO
 !
 !--    Set flag parameter for the prescribed surface type depending on user 
-!--    input.
-       DO  m = 1, surf_lsm_h%ns
-
-          SELECT CASE ( TRIM( surface_type ) )
+!--    input. Set surface fraction to 1 for the respective type.
+       SELECT CASE ( TRIM( surface_type ) )
           
-             CASE ( 'vegetation' )
+          CASE ( 'vegetation' )
          
-                surf_lsm_h%vegetation_surface(m)    = .TRUE.
+             surf_lsm_h%vegetation_surface = .TRUE.
+             surf_lsm_h%frac(ind_veg,:) = 1.0_wp
+             DO  l = 0, 3
+                surf_lsm_v(l)%vegetation_surface = .TRUE.
+                surf_lsm_v(l)%frac(ind_veg,:) = 1.0_wp
+             ENDDO
    
-             CASE ( 'water' )
+          CASE ( 'water' )
              
-                surf_lsm_h%water_surface(m)      = .TRUE.
-
-             CASE ( 'pavement' )
+             surf_lsm_h%water_surface = .TRUE.
+             surf_lsm_h%frac(ind_wat,:) = 1.0_wp
+!
+!--          Note, vertical water surface does not really make sense.
+             DO  l = 0, 3  
+                surf_lsm_v(l)%water_surface   = .TRUE.
+                surf_lsm_v(l)%frac(ind_wat,:) = 1.0_wp
+             ENDDO
+
+          CASE ( 'pavement' )
              
-                surf_lsm_h%pavement_surface(m)   = .TRUE.
-    
-          END SELECT
-  
-       ENDDO
-       
-       DO  l = 0, 3
-          SELECT CASE ( TRIM( surface_type ) )
-          
-             CASE ( 'vegetation' )
-         
-                surf_lsm_v(l)%vegetation_surface = .TRUE.
-   
-             CASE ( 'water' )
-
-                surf_lsm_v(l)%water_surface   = .TRUE.
-
-             CASE ( 'pavement' )
-             
-                surf_lsm_h%pavement_surface   = .TRUE.
-
-          END SELECT   
-
-       ENDDO
-!
-!--    Initialize standard soil types. It is possible to overwrite each
-!--    parameter by setting the respecticy NAMELIST variable to a 
-!--    value /= 9999999.9. 
+             surf_lsm_h%pavement_surface = .TRUE.
+                surf_lsm_h%frac(ind_pav,:) = 1.0_wp
+             DO  l = 0, 3
+                surf_lsm_v(l)%pavement_surface   = .TRUE.
+                surf_lsm_v(l)%frac(ind_pav,:) = 1.0_wp
+             ENDDO
+
+          CASE ( 'netcdf' )
+
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+                IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )        &
+                   surf_lsm_h%vegetation_surface(m) = .TRUE.
+                IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill )          &
+                   surf_lsm_h%pavement_surface(m) = .TRUE.
+                IF ( water_type_f%var(j,i)      /= water_type_f%fill )             &
+                   surf_lsm_h%water_surface(m) = .TRUE.
+             ENDDO
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+!
+!--                Only for vertical surfaces. Check if natural walls at reference
+!--                grid point are covered by any building. This case, problems 
+!--                with initialization will aris if index offsets are used. 
+!--                In order to deal with this, set special flag. 
+                   surf_lsm_v(l)%building_covered(m) = .FALSE.
+                   IF ( building_type_f%from_file )  THEN
+                      i = surf_lsm_v(l)%i(m) + surf_lsm_v(l)%ioff
+                      j = surf_lsm_v(l)%j(m) + surf_lsm_v(l)%joff
+                      IF ( building_type_f%var(j,i) /= 0 )                     &
+                         surf_lsm_v(l)%building_covered(m) = .TRUE.
+                   ENDIF
+!
+!--                Normally proceed with setting surface types.
+                   i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,     &
+                                            surf_lsm_v(l)%building_covered(m) )
+                   j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,     &
+                                            surf_lsm_v(l)%building_covered(m) )
+                   IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill ) &
+                      surf_lsm_v(l)%vegetation_surface(m) = .TRUE.
+                   IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill )   &
+                      surf_lsm_v(l)%pavement_surface(m) = .TRUE.
+                   IF ( water_type_f%var(j,i)      /= water_type_f%fill )      &
+                      surf_lsm_v(l)%water_surface(m) = .TRUE.
+                ENDDO
+             ENDDO
+
+       END SELECT
+!
+!--    In case of netcdf input file, further initialize surface fractions. 
+!--    At the moment only 1 surface is given at a location, so that the fraction
+!--    is either 0 or 1. This will be revised later. 
+       IF ( input_pids_static )  THEN
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+!
+!--          0 - vegetation fraction, 1 - pavement fraction, 2 - water fraction             
+             surf_lsm_h%frac(ind_veg,m) = surface_fraction_f%frac(ind_veg,j,i)         
+             surf_lsm_h%frac(ind_pav,m) = surface_fraction_f%frac(ind_pav,j,i)        
+             surf_lsm_h%frac(ind_wat,m) = surface_fraction_f%frac(ind_wat,j,i)
+
+          ENDDO
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i = surf_lsm_v(l)%i(m) + MERGE( 0, surf_lsm_v(l)%ioff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+                j = surf_lsm_v(l)%j(m) + MERGE( 0, surf_lsm_v(l)%joff,         &
+                                                surf_lsm_v(l)%building_covered(m) ) 
+!
+!--             0 - vegetation fraction, 1 - pavement fraction, 2 - water fraction        
+                surf_lsm_v(l)%frac(ind_veg,m) = surface_fraction_f%frac(ind_veg,j,i)         
+                surf_lsm_v(l)%frac(ind_pav,m) = surface_fraction_f%frac(ind_pav,j,i)        
+                surf_lsm_v(l)%frac(ind_wat,m) = surface_fraction_f%frac(ind_wat,j,i)
+
+             ENDDO
+          ENDDO
+       ENDIF
+!
+!--    Level 1, initialization of soil parameters.
+!--    It is possible to overwrite each parameter by setting the respecticy 
+!--    NAMELIST variable to a value /= 9999999.9. 
        IF ( soil_type /= 0 )  THEN  
  
@@ -2339,131 +2600,4 @@
           IF ( residual_moisture == 9999999.9_wp )  THEN
              residual_moisture = soil_pars(7,soil_type)       
-          ENDIF
-
-       ENDIF    
-  
-!
-!--    Check whether parameters from the lookup tables are to be used
-       IF ( vegetation_type /= 0 )  THEN
-
-          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
-             min_canopy_resistance = vegetation_pars(0,vegetation_type)
-          ENDIF
-
-          IF ( leaf_area_index == 9999999.9_wp )  THEN
-             leaf_area_index = vegetation_pars(1,vegetation_type)         
-          ENDIF
-
-          IF ( vegetation_coverage == 9999999.9_wp )  THEN
-             vegetation_coverage = vegetation_pars(2,vegetation_type)     
-          ENDIF
-
-          IF ( canopy_resistance_coefficient == 9999999.9_wp )  THEN
-              canopy_resistance_coefficient= vegetation_pars(3,vegetation_type)     
-          ENDIF
-
-          IF ( z0_vegetation == 9999999.9_wp )  THEN
-             z0_vegetation  = vegetation_pars(4,vegetation_type) 
-          ENDIF
-
-          IF ( z0h_vegetation == 9999999.9_wp )  THEN
-             z0h_vegetation = vegetation_pars(5,vegetation_type)
-          ENDIF   
-          
-          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
-             lambda_surface_stable = vegetation_pars(6,vegetation_type) 
-          ENDIF
-
-          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
-             lambda_surface_unstable = vegetation_pars(7,vegetation_type)           
-          ENDIF
-
-          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
-             f_shortwave_incoming = vegetation_pars(8,vegetation_type)        
-          ENDIF
-
-          IF ( c_surface == 9999999.9_wp )  THEN
-             c_surface = vegetation_pars(9,vegetation_type)        
-          ENDIF
- 
-          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
-             albedo_type = INT(vegetation_pars(10,vegetation_type))       
-          ENDIF
-   
-          IF ( emissivity == 9999999.9_wp )  THEN
-             emissivity = vegetation_pars(11,vegetation_type)     
-          ENDIF
-          
-       ENDIF
-
-       IF ( water_type /= 0 )  THEN
-
-          IF ( water_temperature == 9999999.9_wp )  THEN
-             water_temperature = water_pars(0,water_type)       
-          ENDIF
-
-          IF ( z0_water == 9999999.9_wp )  THEN
-             z0_water = water_pars(1,water_type)
-          ENDIF       
-
-          IF ( z0h_water == 9999999.9_wp )  THEN
-             z0h_water = water_pars(2,water_type)    
-          ENDIF  
-
-          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
-             albedo_type = INT(water_pars(3,water_type))        
-          ENDIF
-   
-          IF ( emissivity == 9999999.9_wp )  THEN
-             emissivity = water_pars(4,water_type)        
-          ENDIF
-
-       ENDIF 
-       
-       IF ( pavement_type /= 0 )  THEN  
-
-!
-!--       When a pavement_type is used, overwrite a possible setting of 
-!--       the pavement depth as it is already defined by the pavement type
-          pavement_depth_level = 0
-
-          IF ( z0_pavement == 9999999.9_wp )  THEN
-             z0_pavement  = pavement_pars(0,pavement_type) 
-          ENDIF
-
-          IF ( z0h_pavement == 9999999.9_wp )  THEN
-             z0h_pavement = pavement_pars(1,pavement_type)
-          ENDIF
-
-          IF ( pavement_heat_conduct == 9999999.9_wp )  THEN
-             pavement_heat_conduct = pavement_subsurface_pars_1(0,pavement_type)
-          ENDIF
-
-          IF ( pavement_heat_capacity == 9999999.9_wp )  THEN
-             pavement_heat_capacity = pavement_subsurface_pars_2(0,pavement_type)
-          ENDIF   
-    
-          IF ( albedo_type == 9999999  .AND.  albedo == 9999999.9_wp )  THEN
-             albedo_type = INT(pavement_pars(2,pavement_type))        
-          ENDIF
-   
-          IF ( emissivity == 9999999.9_wp )  THEN
-             emissivity = pavement_pars(3,pavement_type)        
-          ENDIF
-
-!
-!--       If the depth level of the pavement is not set, determine it from
-!--       lookup table.
-          IF ( pavement_depth_level == 0 )  THEN
-             DO  k = nzb_soil, nzt_soil  
-                IF ( pavement_subsurface_pars_1(k,pavement_type) == 9999999.9_wp &
-                   .OR. pavement_subsurface_pars_2(k,pavement_type)              &
-                   == 9999999.9_wp)  THEN
-                   nzt_pavement = k-1
-                   EXIT
-                ENDIF
-             ENDDO
-          ELSE
-             nzt_pavement = pavement_depth_level
           ENDIF
 
